Attribute VB_Name = "ModListView_util"
' *******************************************************************************
' VB81 XuR
' ModListView_util.bas - Added by XavSnap. (2007)
' *******************************************************************************

' From Randy Birch
' http://ewbi.blogs.com/develops/2003/10/resizing_listvi.html
' Google.

Private Type RECT
    Left As Long
    top As Long
    Right As Long
    Bottom As Long
End Type

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Long) As Long
Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageAny Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageArray Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function SendMessageString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As String) As Long
 
Public gListViewTotalSelected As Long
Public gListViewSelected() As Long
Public gListViewItemToInsertBefore As Long

Public Const LVFI_PARAM = &H1
Public Const LVFI_STRING = &H2
Public Const LVFI_PARTIAL = &H8
Public Const LVFI_WRAP = &H20
Public Const LVFI_NEARESTXY = &H40
Public Const LVS_EX_FULLROWSELECT = &H20
Public Const LVSCW_AUTOSIZE As Long = -1
Public Const LVSCW_AUTOSIZE_USEHEADER As Long = -2

Public Type HD_ITEM
      
      mask        As Long
      cxy         As Long
      pszText     As String
      hbm         As Long
      cchTextMax  As Long
      fmt         As Long
      lParam      As Long
      iImage      As Long
      iOrder      As Long
      
End Type



Type POINTAPI
        X As Long
        y As Long
End Type

Public Type LV_FINDINFO
      
      flags As Long
      psz As String
      lParam As Long
      pt As POINTAPI
      vkDirection As Long

End Type

Public Type LV_ITEM
      
      mask As Long
      iItem As Long
      iSubItem As Long
      State As Long
      stateMask As Long
      pszText As Long
      cchTextMax As Long
      iImage As Long
      lParam As Long
      iIndent As Long

End Type


Declare Function GetListViewItemHeight Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As RECT) As Long

Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, _
                                                                  ByVal nCount As Long, lpRect As RECT, _
                                                                  ByVal wFormat As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long

Private Const LB_SETHORIZONTALEXTENT = &H194
Private Const DT_CALCRECT = &H400
Private Const SM_CXVSCROLL = 2
Private Const SET_COLUMN_WIDTH = 4126


' Send massage constants.
Public Const HDS_HOTTRACK = &H4

Public Const HDI_BITMAP = &H10
Public Const HDI_IMAGE = &H20
Public Const HDI_ORDER = &H80
Public Const HDI_FORMAT = &H4
Public Const HDI_TEXT = &H2
Public Const HDI_WIDTH = &H1
Public Const HDI_HEIGHT = HDI_WIDTH

Public Const HDF_LEFT = 0
Public Const HDF_RIGHT = 1
Public Const HDF_IMAGE = &H800
Public Const HDF_BITMAP_ON_RIGHT = &H1000
Public Const HDF_BITMAP = &H2000
Public Const HDF_STRING = &H4000

Public Const HDM_FIRST = &H1200
Public Const HDM_SETITEM = (HDM_FIRST + 4)
Public Const LVM_FIRST = &H1000
Public Const LVM_GETHEADER = (LVM_FIRST + 31)
Public Const LVM_GETBKCOLOR = (LVM_FIRST + 0)
Public Const LVM_SETBKCOLOR = (LVM_FIRST + 1)
Public Const LVM_GETIMAGELIST = (LVM_FIRST + 2)
Public Const LVM_SETIMAGELIST = (LVM_FIRST + 3)
Public Const LVM_GETITEMCOUNT = (LVM_FIRST + 4)
Public Const LVM_GETITEMA = (LVM_FIRST + 5)
Public Const LVM_GETITEM = LVM_GETITEMA
Public Const LVM_SETITEMA = (LVM_FIRST + 6)
Public Const LVM_SETITEM = LVM_SETITEMA
Public Const LVM_INSERTITEMA = (LVM_FIRST + 7)
Public Const LVM_INSERTITEM = LVM_INSERTITEMA
Public Const LVM_DELETEITEM = (LVM_FIRST + 8)
Public Const LVM_DELETEALLITEMS = (LVM_FIRST + 9)
Public Const LVM_GETCALLBACKMASK = (LVM_FIRST + 10)
Public Const LVM_SETCALLBACKMASK = (LVM_FIRST + 11)
Public Const LVM_GETNEXTITEM = (LVM_FIRST + 12)
Public Const LVM_FINDITEMA = (LVM_FIRST + 13)
Public Const LVM_FINDITEM = LVM_FINDITEMA
Public Const LVM_GETITEMRECT = (LVM_FIRST + 14)
Public Const LVM_SETITEMPOSITION = (LVM_FIRST + 15)
Public Const LVM_GETITEMPOSITION = (LVM_FIRST + 16)
Public Const LVM_GETSTRINGWIDTHA = (LVM_FIRST + 17)
Public Const LVM_GETSTRINGWIDTH = LVM_GETSTRINGWIDTHA
Public Const LVM_HITTEST = (LVM_FIRST + 18)
Public Const LVM_ENSUREVISIBLE = (LVM_FIRST + 19)
Public Const LVM_SCROLL = (LVM_FIRST + 20)
Public Const LVM_REDRAWITEMS = (LVM_FIRST + 21)
Public Const LVM_ARRANGE = (LVM_FIRST + 22)
Public Const LVM_EDITLABELA = (LVM_FIRST + 23)
Public Const LVM_EDITLABEL = LVM_EDITLABELA
Public Const LVM_GETEDITCONTROL = (LVM_FIRST + 24)
Public Const LVM_GETCOLUMNA = (LVM_FIRST + 25)
Public Const LVM_GETCOLUMN = LVM_GETCOLUMNA
Public Const LVM_SETCOLUMNA = (LVM_FIRST + 26)
Public Const LVM_SETCOLUMN = LVM_SETCOLUMNA
Public Const LVM_INSERTCOLUMNA = (LVM_FIRST + 27)
Public Const LVM_INSERTCOLUMN = LVM_INSERTCOLUMNA
Public Const LVM_DELETECOLUMN = (LVM_FIRST + 28)
Public Const LVM_GETCOLUMNWIDTH = (LVM_FIRST + 29)
Public Const LVM_SETCOLUMNWIDTH = (LVM_FIRST + 30)
Public Const LVM_CREATEDRAGIMAGE = (LVM_FIRST + 33)
Public Const LVM_GETVIEWRECT = (LVM_FIRST + 34)
Public Const LVM_GETTEXTCOLOR = (LVM_FIRST + 35)
Public Const LVM_SETTEXTCOLOR = (LVM_FIRST + 36)
Public Const LVM_GETTEXTBKCOLOR = (LVM_FIRST + 37)
Public Const LVM_SETTEXTBKCOLOR = (LVM_FIRST + 38)
Public Const LVM_GETTOPINDEX = (LVM_FIRST + 39)
Public Const LVM_GETCOUNTPERPAGE = (LVM_FIRST + 40)
Public Const LVM_GETORIGIN = (LVM_FIRST + 41)
Public Const LVM_UPDATE = (LVM_FIRST + 42)
Public Const LVM_SETITEMSTATE = (LVM_FIRST + 43)
Public Const LVM_GETITEMSTATE = (LVM_FIRST + 44)
Public Const LVM_GETITEMTEXTA = (LVM_FIRST + 45)
Public Const LVM_GETITEMTEXT = LVM_GETITEMTEXTA
Public Const LVM_SETITEMTEXTA = (LVM_FIRST + 46)
Public Const LVM_SETITEMTEXT = LVM_SETITEMTEXTA
Public Const LVM_SETITEMCOUNT = (LVM_FIRST + 47)
Public Const LVM_SORTITEMS = (LVM_FIRST + 48)
Public Const LVM_SETITEMPOSITION32 = (LVM_FIRST + 49)
Public Const LVM_GETSELECTEDCOUNT = (LVM_FIRST + 50)
Public Const LVM_GETITEMSPACING = (LVM_FIRST + 51)
Public Const LVM_GETISEARCHSTRINGA = (LVM_FIRST + 52)
Public Const LVM_GETISEARCHSTRING = LVM_GETISEARCHSTRINGA
Public Const LVM_SETICONSPACING = (LVM_FIRST + 53)
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54)
Public Const LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55)
Public Const LVM_GETSUBITEMRECT = (LVM_FIRST + 56)
Public Const LVM_SUBITEMHITTEST = (LVM_FIRST + 57)
Public Const LVM_SETCOLUMNORDERARRAY = (LVM_FIRST + 58)
Public Const LVM_GETCOLUMNORDERARRAY = (LVM_FIRST + 59)
Public Const LVM_SETHOTITEM = (LVM_FIRST + 60)
Public Const LVM_GETHOTITEM = (LVM_FIRST + 61)
Public Const LVM_SETHOTCURSOR = (LVM_FIRST + 62)
Public Const LVM_GETHOTCURSOR = (LVM_FIRST + 63)
Public Const LVM_APPROXIMATEVIEWRECT = (LVM_FIRST + 64)



 Sub AutosizeColumns(ByVal TargetListView As ListView)

  Const AUTOSIZE_USEHEADER  As Long = -2

  Dim lngColumn As Long

  
  For lngColumn = 0 To (TargetListView.ColumnHeaders.count - 1)
   
    Call SendMessage(TargetListView.hwnd, _
                     SET_COLUMN_WIDTH, _
                     lngColumn, _
                     ByVal AUTOSIZE_USEHEADER)
        
  Next lngColumn

End Sub

' Manual resize. (calculate text width and set column header to max lenght)
' from start to end list for a specific column.
' SetColumWith window.hdc, object , #column , Fist Raw , Last Raw
' OPTIONAL = default colum#1 , raw#1 , last raw.

Public Sub SetColumWidth(ByVal hdc As Long, MaListe As ListView, Optional Column As Integer = 0, Optional First_Index = 1, Optional Last_Index = -1)

If MaListe.ListItems.count = 0 Then Exit Sub
    
    Dim compteur As Long, Nlargeur As Long, LargText As Long, sysScrollWidth As Long
    Dim rcText As RECT, NbSpace As Integer
           
    If Last_Index = -1 Then Last_Index = MaListe.ListItems.count
    
    If First_Index >= Last_Index Then First_Index = Last_Index
    
    sysScrollWidth = GetSystemMetrics(SM_CXVSCROLL)
    For compteur = First_Index To Last_Index
           DrawText hdc, MaListe.ListItems.Item(compteur), -1&, rcText, DT_CALCRECT
           LargText = rcText.Right + sysScrollWidth
           
' Warning: This methode seem to swap space detection ! (a space lenght is null)
'          we must add space character to get his lenght.
'
NbSpace = CharCounter(MaListe.ListItems.Item(compteur), Chr(32))

           If NbSpace > 0 Then
           DrawText hdc, SPChar(NbSpace, "_"), -1&, rcText, DT_CALCRECT
           LargText = LargText + rcText.Right
           End If
' end of space traitement.
        
           If LargText >= Nlargeur Then
                Nlargeur = LargText + 30
           End If
    Next compteur
    
    Call SendMessage(MaListe.hwnd, _
                     SET_COLUMN_WIDTH, _
                     Column, _
                     ByVal Nlargeur)
   
End Sub


Sub ListView_BK_Col(MaListe As ListView, Back_Color As Long, Col_id As Long)
'general

Const LVM_SETTEXTBKCOLOR = (&H1000 + 38)

'((hwnd), LVM_SETTEXTBKCOLOR, 0, (LPARAM)(COLORREF)(clrTextBk))
    Call SendMessage(MaListe.hwnd, _
                     LVM_SETTEXTBKCOLOR, _
                     Col_id, _
                     ByVal Back_Color)

End Sub
Sub ListView_Fore_Col(MaListe As ListView, Fore_Color As Long)
'general
'      For Each obj In ctl.ColumnHeaders
'                obj.text = LoadResString(CInt(obj.Tag))
'            Next
            
Dim obj2 As Variant
Dim obj As Variant
'MaListe.ListItems.Item.ListSubItems.Item.
For Each obj In MaListe.ListItems
             If Left(obj.Text, 1) <> "_" Then obj.ForeColor = Fore_Color Else obj.ForeColor = &HFFFFFF
             For Each obj2 In obj.ListSubItems
             obj2.ForeColor = Fore_Color
Next
Next

MaListe.Refresh
End Sub
Function CharCounter(char As String, ref_char As String) As Integer
'Enum all ref_char in a char string.
'CharCounter("*xxx*x**xx","*") => return = 4
'CharCounter("*xxx*x**xx","x") => return = 6
'CharCounter("*xxx*x**xx","+") => return = 0 (!!!) COOOooool!
'
Dim Cnt As Integer
Dim a As Integer

a = 1
Cnt = 0
Do While a <= Len(char)
If InStr(a, char, ref_char, vbBinaryCompare) <> 0 Then Cnt = Cnt + 1: a = InStr(a, char, ref_char) + 1 Else Exit Do
Loop

CharCounter = Cnt
End Function

Function SPChar(number As Integer, char As String) As String

Dim a As Integer
Dim TmpChar As String

a = 0
TmpChar = ""

Do While a < number
    TmpChar = TmpChar + char: a = a + 1
Loop

SPChar = TmpChar
End Function

Function ISLVKEY(Mykey As String, LV As ListView) As Boolean
ISLVKEY = False

For Each itm In LV.ListItems
If itm.Key = Mykey Then ISLVKEY = True: Exit For
Next
End Function
Public Sub ListViewGetSelectedItems(ByVal FormToUse As Form, ByVal ListViewControl As Control)

  Dim Counter As Long
  Dim SelectedCount As Long
  
  FormToUse.MousePointer = vbHourglass
  FormToUse.Enabled = False
  
  SelectedCount = 0
  gListViewTotalSelected = SendMessage(ListViewControl.hwnd, LVM_GETSELECTEDCOUNT, 0, 0)

  If gListViewTotalSelected > 0 Then

    ReDim gListViewSelected(gListViewTotalSelected) As Long
  
    For Counter = 1 To ListViewControl.ListItems.count
     
       If ListViewControl.ListItems(Counter).Selected = True Then
       
         gListViewSelected(SelectedCount) = Counter
         SelectedCount = SelectedCount + 1
       
       End If
     
    Next Counter

  End If

  FormToUse.Enabled = True
  FormToUse.MousePointer = vbDefault
  
End Sub
Public Sub AutoFitColumnWidth(ByVal lvw As ListView)

  Dim iCounter As Long

  On Error Resume Next
  If lvw.View = lvwReport Then
    
    For iCounter = 1 To lvw.ColumnHeaders.count
   
       If iCounter > 1 Then
         
         If lvw.ColumnHeaders(iCounter - 1).Tag = "DATE" Then

           lvw.ColumnHeaders(iCounter).Width = 0

         Else

           Call SendMessage(lvw.hwnd, LVM_SETCOLUMNWIDTH, iCounter - 1, ByVal LVSCW_AUTOSIZE_USEHEADER)

         End If
         
       Else
         
         Call SendMessage(lvw.hwnd, LVM_SETCOLUMNWIDTH, iCounter - 1, ByVal LVSCW_AUTOSIZE_USEHEADER)
       
       End If

    Next
    
  End If
  Call FixSortedColumnHeaderIfNeeded(lvw)
  On Error GoTo 0
  
End Sub
Public Sub AutoSizeColumnWidth(ByVal lvw As ListView)

  Dim iCounter As Long

  On Error Resume Next
  If lvw.View = lvwReport Then
    
    For iCounter = 1 To lvw.ColumnHeaders.count ' - 1
   
       If iCounter > 1 Then
         
         If lvw.ColumnHeaders(iCounter - 1).Tag = "DATE" Then

           lvw.ColumnHeaders(iCounter).Width = 0

         Else

           Call SendMessage(lvw.hwnd, LVM_SETCOLUMNWIDTH, iCounter - 1, ByVal LVSCW_AUTOSIZE)

         End If
       
       Else
         
         Call SendMessage(lvw.hwnd, LVM_SETCOLUMNWIDTH, iCounter - 1, ByVal LVSCW_AUTOSIZE)
         
       End If

    Next
    
  End If
  Call FixSortedColumnHeaderIfNeeded(lvw)
  On Error GoTo 0
  
End Sub

Public Sub FixDateSortedColumnHeaderIfNeeded(ByVal ListViewToUse As ListView)
    
  Dim SaveFontSize As Currency
  Dim SaveFontBold As Currency
  Dim SaveFontName As String
  
  SaveFontSize = ListViewToUse.Parent.Font.Size
  SaveFontBold = ListViewToUse.Parent.Font.Bold
  SaveFontName = ListViewToUse.Parent.Font.Name
  
  ListViewToUse.Parent.Font.Size = ListViewToUse.Font.Size
  ListViewToUse.Parent.Font.Bold = ListViewToUse.Font.Bold
  ListViewToUse.Parent.Font.Name = ListViewToUse.Font.Name
  
  If ListViewToUse.ColumnHeaders(IIf(ListViewToUse.SortKey = 0, 1, ListViewToUse.SortKey)).Width < ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(IIf(ListViewToUse.SortKey = 0, 1, ListViewToUse.SortKey)).Text) + ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(IIf(ListViewToUse.SortKey = 0, 1, ListViewToUse.SortKey)).Text) \ 2 Then

    ListViewToUse.ColumnHeaders(IIf(ListViewToUse.SortKey = 0, 1, ListViewToUse.SortKey)).Width = ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(IIf(ListViewToUse.SortKey = 0, 1, ListViewToUse.SortKey)).Text) + ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(IIf(ListViewToUse.SortKey = 0, 1, ListViewToUse.SortKey)).Text) \ 2

  End If
  
  ListViewToUse.Parent.Font.Size = SaveFontSize
  ListViewToUse.Parent.Font.Bold = SaveFontBold
  ListViewToUse.Parent.Font.Name = SaveFontName

End Sub
Public Sub FixSortedColumnHeaderIfNeeded(ByVal ListViewToUse As ListView)
  
  Dim SaveFontSize As Currency
  Dim SaveFontBold As Currency
  Dim SaveFontName As String
  
  If ListViewToUse.ColumnHeaders(IIf(ListViewToUse.SortKey = 0, 1, ListViewToUse.SortKey)).Tag = "DATE" Then
    
    Call FixDateSortedColumnHeaderIfNeeded(ListViewToUse)
    
  Else
    
    SaveFontSize = ListViewToUse.Parent.Font.Size
    SaveFontBold = ListViewToUse.Parent.Font.Bold
    SaveFontName = ListViewToUse.Parent.Font.Name
  
    ListViewToUse.Parent.Font.Size = ListViewToUse.Font.Size
    ListViewToUse.Parent.Font.Bold = ListViewToUse.Font.Bold
    ListViewToUse.Parent.Font.Name = ListViewToUse.Font.Name
  
    If ListViewToUse.ColumnHeaders(ListViewToUse.SortKey + 1).Width < ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(ListViewToUse.SortKey + 1).Text) + ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(ListViewToUse.SortKey + 1).Text) \ 2 Then
    
      ListViewToUse.ColumnHeaders(ListViewToUse.SortKey + 1).Width = ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(ListViewToUse.SortKey + 1).Text) + ListViewToUse.Parent.TextWidth(ListViewToUse.ColumnHeaders(ListViewToUse.SortKey + 1).Text) \ 2
    
    End If
  
    ListViewToUse.Parent.Font.Size = SaveFontSize
    ListViewToUse.Parent.Font.Bold = SaveFontBold
    ListViewToUse.Parent.Font.Name = SaveFontName
    
  End If

End Sub
Public Function GetListViewItemIndex(ByVal hwnd As Long, ByVal ItemText As String) As Long
  
  Dim LFI As LV_FINDINFO
  
  LFI.flags = LVFI_PARTIAL Or LVFI_WRAP
  LFI.psz = ItemText
  
  GetListViewItemIndex = SendMessageAny(hwnd, LVM_FINDITEM, -1, LFI)
  
  If GetListViewItemIndex <> -1 Then
    
    GetListViewItemIndex = GetListViewItemIndex + 1
    
  End If
  
End Function
Public Sub SetListViewToWholeRowSelect(ByVal ListViewhWnd As Long)
    
  Dim lStyle As Long
  
  lStyle = SendMessage(ListViewhWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0)
  lStyle = lStyle Or LVS_EX_FULLROWSELECT
  
  Call SendMessage(ListViewhWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, ByVal lStyle)

End Sub

Public Sub ShowHeaderIcon(ByVal ListViewToUse As Control, ByVal colNo As Long, ByVal showImage As Long)

  Dim r As Long
  Dim hHeader As Long
  Dim HD As HD_ITEM
   
  'ListViewToUse.SmallIcons = FrmAudit.ImagesICONS
  
  ' Get a handle to the listview header component '
   hHeader = SendMessageLong(ListViewToUse.hwnd, LVM_GETHEADER, 0, 0)
   
  ' Set up the required structure members '
  HD.mask = HDI_IMAGE Or HDI_FORMAT
  HD.fmt = HDF_LEFT Or HDF_STRING Or HDF_BITMAP_ON_RIGHT Or showImage
  HD.pszText = ListViewToUse.ColumnHeaders(ListViewToUse.SortKey + 1).Text
  
  If showImage Then
    
    HD.iImage = ListViewToUse.SortOrder
    
  End If
   
  ' Modify the header '
  r = SendMessageAny(hHeader, HDM_SETITEM, colNo, HD)
   
End Sub

' --------------------------------------------------------------------------------
' Sort ...
' --------------------------------------------------------------------------------

Public Sub SortDateListView(ByVal ListViewToUse As ListView, ByVal colNo As Long)
  
  Dim Counter As Long
  
  If colNo = ListViewToUse.SortKey Then
    
    If ListViewToUse.SortOrder = lvwAscending Then
  
      ListViewToUse.SortOrder = lvwDescending
    
    Else
     
      ListViewToUse.SortOrder = lvwAscending
  
    End If
  
  End If
  
  ListViewToUse.Sorted = True
  ListViewToUse.SortKey = colNo
  
  For Counter = 1 To ListViewToUse.ColumnHeaders.count
  
     If Counter = colNo Then
       
       Call ShowHeaderIcon(ListViewToUse, colNo - 1, HDF_IMAGE)
    
     Else
       
       Call ShowHeaderIcon(ListViewToUse, Counter - 1, 0)
     
     End If
     
  Next Counter
  Call FixDateSortedColumnHeaderIfNeeded(ListViewToUse)

End Sub
Public Sub SortListView(ByVal ListViewToUse As ListView, ByVal colNo As Long)
  
  Dim Counter As Long
  
  If ListViewToUse.ColumnHeaders(colNo).Tag = "DATE" Then
    
    Call SortDateListView(ListViewToUse, colNo)
    
  Else
    
    If colNo - 1 = ListViewToUse.SortKey Then
    
      If ListViewToUse.SortOrder = lvwAscending Then
  
        ListViewToUse.SortOrder = lvwDescending
    
      Else
     
        ListViewToUse.SortOrder = lvwAscending
  
      End If
  
    End If
  
    ListViewToUse.Sorted = True
    ListViewToUse.SortKey = colNo - 1
  
    For Counter = 0 To ListViewToUse.ColumnHeaders.count - 1
  
       If Counter = ListViewToUse.SortKey Then
       
         Call ShowHeaderIcon(ListViewToUse, ListViewToUse.SortKey, HDF_IMAGE)
    
       Else
       
         Call ShowHeaderIcon(ListViewToUse, Counter, 0)
     
       End If
     
    Next Counter
    Call FixSortedColumnHeaderIfNeeded(ListViewToUse)

  End If
  
End Sub

